Debian Bug report logs - #698674
Multiarchify tcl

version graph

Package: tcl8.5; Maintainer for tcl8.5 is Debian Tcl/Tk Packagers <pkg-tcltk-devel@lists.alioth.debian.org>; Source for tcl8.5 is src:tcl8.5.

Reported by: Wookey <wookey@wookware.org>

Date: Tue, 22 Jan 2013 03:45:02 UTC

Severity: normal

Tags: jessie, patch, sid

Found in version tcl8.5/8.5.11-2

Fixed in version 8.5.15-4

Done: Sergei Golovan <sgolovan@nes.ru>

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#698674; Package tcl8.5. (Tue, 22 Jan 2013 03:45:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
New Bug report received and forwarded. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Tue, 22 Jan 2013 03:45:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Multiarchify tcl
Date: Tue, 22 Jan 2013 03:41:40 +0000
[Message part 1 (text/plain, inline)]
Package: tcl8.5
Version: 8.5.11-2
Severity: normal
Tags: sid patch
User: multiarch-devel@lists.alioth.debian.org
Usertag: multiarch

TCL has not been 'multiarched'. This task has been pending for a
couple of years, ever since I noticed that tclConfig.sh is
arch-specific in #611650. The lack of this bit me today trying to
cross-build sqlite3 which looked for tclConfig.sh in
/usr/lib/$(DEB_HOST_MULTIARCH)/tclConfig.sh which is the right place,
but the script isn't there. So I finally had a go at multiarching the
package.

I don't know if this is sufficient or complete as I'm not familiar
with the internal working of tcl, but it's fairly conservative so
should work. Essentially the .so and .a libs, and the tclConfig.sh
config script are all moved into multiarch directories in the existing
tcl8.5-dev and a new tcl8.5-lib package for the runtime library. Both
these packages are Multi-Arch: same and thus co-installable.

All the other files remain in the tcl8.5 package, although I don't
know if there are arch-specific files in there which should move? That
package is MA: foreign as tcl is able to run scripts in an
arch-independent fashion. 

I left a tight binary-version dependency of tcl8.5 on tcl8.5-lib so
you always get matching versions. I'm not sure if this is necessary -
is a tight version match needed here?

It all seems to build correctly, and cross-build OK too (with the patch
in #631995)

I will test these packages for use in crossbulding, but I would
welcome feedback on whether something more complex is needed to make
this work for all tcl roles (embedded interpreter, etc). 

Whilst testing this I noticed that the unix dir wasn't getting
cleaned, so a second build fell over. I've fixed that too. 

-- System Information:
Debian Release: 6.0.6
  APT prefers stable
  APT policy: (990, 'stable')
Architecture: i386 (i686)

Kernel: Linux 2.6.32.33-kvm-i386-20111128-dirty (SMP w/1 CPU core)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash
[tcl8.5-8.5.11-2-multiarchify.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#698674; Package tcl8.5. (Fri, 05 Apr 2013 11:12:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Matthias Klose <doko@ubuntu.com>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Fri, 05 Apr 2013 11:12:04 GMT) Full text and rfc822 format available.

Message #10 received at 698674@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@ubuntu.com>
To: 703421@bugs.debian.org, 698674@bugs.debian.org, Wookey <wookey@wookware.org>
Subject: Tcl/Tk multiarching
Date: Fri, 05 Apr 2013 13:08:00 +0200
Some comments for the Tcl/Tk multiarch changes, now that the first bits are in
Ubuntu 13.04 (raring).

 - The move of tclConfig.sh tkConfig.sh to the multiarch location did
   cause some build breakage. In the end we do provide now compat
   symlinks in /usr/lib to fix the build breakage. This works for
   most cases, but not if a specific version of Tcl/Tk is targeted,
   e.g. itcl, itk.

   So a test rebuild in Debian might be needed before this is done.

 - From my point of view, the multiarch view is still incomplete.
   You should be able to install an embedded interpreter of the
   foreign arch while keeping the interpreter of the native arch
   installed on the system. E.g. on amd64, install vim for i386,
   and still have the amd64 tclsh installed. Maybe vim is not
   a good use case, but e.g. installing an amd64 gdb with the
   embedded python interpreter on i386 works while keeping the
   python interpreter on amd64.

   For Tcl/Tk this would involve to move the required library
   (text/script) files to the tcllib8.5 package too.
   Tracking this in Ubuntu in LP: #1164937.

Matthias



Added tag(s) jessie. Request was from Julien Cristau <jcristau@debian.org> to control@bugs.debian.org. (Thu, 18 Apr 2013 17:37:00 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#698674; Package tcl8.5. (Fri, 12 Jul 2013 08:27:18 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sergei Golovan <sgolovan@nes.ru>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Fri, 12 Jul 2013 08:27:18 GMT) Full text and rfc822 format available.

Message #17 received at 698674@bugs.debian.org (full text, mbox):

From: Sergei Golovan <sgolovan@nes.ru>
To: Wookey <wookey@wookware.org>, 698674@bugs.debian.org
Subject: Re: [Pkg-tcltk-devel] Bug#698674: Multiarchify tcl
Date: Fri, 12 Jul 2013 12:25:18 +0400
Hi Wookey!

On Tue, Jan 22, 2013 at 7:41 AM, Wookey <wookey@wookware.org> wrote:
>
> TCL has not been 'multiarched'. This task has been pending for a
> couple of years, ever since I noticed that tclConfig.sh is
> arch-specific in #611650. The lack of this bit me today trying to
> cross-build sqlite3 which looked for tclConfig.sh in
> /usr/lib/$(DEB_HOST_MULTIARCH)/tclConfig.sh which is the right place,
> but the script isn't there. So I finally had a go at multiarching the
> package.

I've started working on multiarch Tcl/Tk and already uploaded tcl8.6 into
experimental (it's in NEW now). I'm planning to upload tcl8.5 and tcl8.4
in a few days, and then tk*.*. There are only two essential differences
between your and my approaches: 1) I ship all Tcl stuff in tcl8.6-lib package
(which should make it work with embedded interpreters, though it's untested
yet); 2) I've added /usr/lib/tcltk/$(DEB_HOST_MULTIARCH) to the Tcl package
search path (this helps with multiarch-aware packages like Tk).

Cheers!
--
Sergei Golovan



Added tag(s) pending. Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Fri, 12 Jul 2013 20:06:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#698674; Package tcl8.5. (Tue, 30 Jul 2013 14:42:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Dmitrijs Ledkovs <xnox@debian.org>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Tue, 30 Jul 2013 14:42:05 GMT) Full text and rfc822 format available.

Message #24 received at 698674@bugs.debian.org (full text, mbox):

From: Dmitrijs Ledkovs <xnox@debian.org>
To: 703421@bugs.debian.org, 698674@bugs.debian.org, Wookey <wookey@wookware.org>
Subject: Tcl/Tk multiarching
Date: Tue, 30 Jul 2013 15:38:43 +0100
To address many of FTBFS bugs, I did in the end introduce a compat
tclConfig.sh tkConfig.sh in non-multiarch locations for Ubuntu, that
simply call dpkg-architecture and source the multi-arched variant.

This solved most of the bugs, but there are still some software that
either hardcoded locations of the default versioned tk/tcl or, in case
of ruby, instead of source the configuration file, it tries to read in
& parse the file by itself.

Regards,

Dmitrijs.



Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#698674; Package tcl8.5. (Tue, 30 Jul 2013 15:06:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sergei Golovan <sgolovan@nes.ru>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Tue, 30 Jul 2013 15:06:04 GMT) Full text and rfc822 format available.

Message #29 received at 698674@bugs.debian.org (full text, mbox):

From: Sergei Golovan <sgolovan@nes.ru>
To: Dmitrijs Ledkovs <xnox@debian.org>, 698674@bugs.debian.org
Subject: Re: [Pkg-tcltk-devel] Bug#698674: Tcl/Tk multiarching
Date: Tue, 30 Jul 2013 19:02:30 +0400
Hi Dmitrijs,

On Tue, Jul 30, 2013 at 6:38 PM, Dmitrijs Ledkovs <xnox@debian.org> wrote:
> To address many of FTBFS bugs, I did in the end introduce a compat
> tclConfig.sh tkConfig.sh in non-multiarch locations for Ubuntu, that
> simply call dpkg-architecture and source the multi-arched variant.

I did copy your approach for packages in experimental. They've stuck
in the new queue for some time, but will go to the archive for testing
eventually.

>
> This solved most of the bugs, but there are still some software that
> either hardcoded locations of the default versioned tk/tcl or, in case
> of ruby, instead of source the configuration file, it tries to read in
> & parse the file by itself.

We'll report bugs for these packages (in fact, I hope that most of the
bugs will be spotted during periodic archive rebuild, after the new
Tcl/Tk will hit sid).

Cheers!
-- 
Sergei Golovan



Reply sent to Sergei Golovan <sgolovan@nes.ru>:
You have taken responsibility. (Fri, 11 Apr 2014 09:21:11 GMT) Full text and rfc822 format available.

Notification sent to Wookey <wookey@wookware.org>:
Bug acknowledged by developer. (Fri, 11 Apr 2014 09:21:11 GMT) Full text and rfc822 format available.

Message #34 received at 698674-done@bugs.debian.org (full text, mbox):

From: Sergei Golovan <sgolovan@nes.ru>
To: 698674-done@bugs.debian.org
Subject: The bug is fixed
Date: Fri, 11 Apr 2014 13:17:25 +0400
Version: 8.5.15-4

Hi!

This bug is fixed. Tcl/Tk 8.5 supports multiarch now.

Cheers!
-- 
Sergei Golovan



Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 04:50:34 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.